/*
 * This file was generated by the CommonAPI Generators.
 * Used org.genivi.commonapi.someip 3.2.0.v202012010944.
 * Used org.franca.core 0.13.1.201807231814.
 *
 * This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
 * If a copy of the MPL was not distributed with this file, You can obtain one at
 * http://mozilla.org/MPL/2.0/.
 */
#include <v2/Test/Audio/ControllerSomeIPProxy.hpp>

#if !defined (COMMONAPI_INTERNAL_COMPILATION)
#define COMMONAPI_INTERNAL_COMPILATION
#define HAS_DEFINED_COMMONAPI_INTERNAL_COMPILATION_HERE
#endif

#include <CommonAPI/SomeIP/AddressTranslator.hpp>

#if defined (HAS_DEFINED_COMMONAPI_INTERNAL_COMPILATION_HERE)
#undef COMMONAPI_INTERNAL_COMPILATION
#undef HAS_DEFINED_COMMONAPI_INTERNAL_COMPILATION_HERE
#endif

namespace v2 {
namespace Test {
namespace Audio {

std::shared_ptr<CommonAPI::SomeIP::Proxy> createControllerSomeIPProxy(
    const CommonAPI::SomeIP::Address &_address,
    const std::shared_ptr<CommonAPI::SomeIP::ProxyConnection> &_connection) {
    return std::make_shared< ControllerSomeIPProxy>(_address, _connection);
}

void initializeControllerSomeIPProxy() {
    CommonAPI::SomeIP::AddressTranslator::get()->insert(
        "local:Test.Audio.Controller:v2_0:Test_Audio_Controller",
        0x16c2, 0x1, 2, 0);
    CommonAPI::SomeIP::Factory::get()->registerProxyCreateMethod(
        "Test.Audio.Controller:v2_0",
        &createControllerSomeIPProxy);
}

INITIALIZER(registerControllerSomeIPProxy) {
    CommonAPI::SomeIP::Factory::get()->registerInterface(initializeControllerSomeIPProxy);
}

ControllerSomeIPProxy::ControllerSomeIPProxy(
    const CommonAPI::SomeIP::Address &_address,
    const std::shared_ptr<CommonAPI::SomeIP::ProxyConnection> &_connection)
        : CommonAPI::SomeIP::Proxy(_address, _connection),
          iVIDeviceInfo_(*this, CommonAPI::SomeIP::eventgroup_id_t(0x1001), CommonAPI::SomeIP::event_id_t(0xa001), CommonAPI::SomeIP::method_id_t(0x2001), false, CommonAPI::SomeIP::reliability_type_e::RT_UNRELIABLE, false, CommonAPI::SomeIP::method_id_t(0x2000), false, static_cast< ::v2::Test::Audio::Controller_::KeyValueStringDeployment_t* >(nullptr)),
          audioSourceTypes_(*this, CommonAPI::SomeIP::eventgroup_id_t(0x1001), CommonAPI::SomeIP::event_id_t(0xa002), CommonAPI::SomeIP::method_id_t(0x2002), false, CommonAPI::SomeIP::reliability_type_e::RT_UNRELIABLE, false, static_cast< CommonAPI::SomeIP::ArrayDeployment< CommonAPI::SomeIP::StringDeployment >* >(nullptr)),
          volumeInfo_(*this, CommonAPI::SomeIP::eventgroup_id_t(0x1001), CommonAPI::SomeIP::event_id_t(0xa003), CommonAPI::SomeIP::method_id_t(0x2003), false, CommonAPI::SomeIP::reliability_type_e::RT_UNRELIABLE, false, static_cast< ::v2::Test::Audio::Controller_::VolumeInfoDeployment_t* >(nullptr)),
          keyValueByteBufferMap_(*this, CommonAPI::SomeIP::eventgroup_id_t(0x1001), CommonAPI::SomeIP::event_id_t(0xa004), CommonAPI::SomeIP::method_id_t(0x2004), false, CommonAPI::SomeIP::reliability_type_e::RT_UNRELIABLE, false, static_cast< ::v2::Test::Audio::Controller_::KeyValueByteBufferDeployment_t* >(nullptr)),
          deviceStateMap_(*this, CommonAPI::SomeIP::eventgroup_id_t(0x1001), CommonAPI::SomeIP::event_id_t(0xa005), CommonAPI::SomeIP::method_id_t(0x2005), false, CommonAPI::SomeIP::reliability_type_e::RT_UNRELIABLE, false, static_cast< ::v2::Test::Audio::Controller_::DeviceStateMapDeployment_t* >(nullptr)),
          stringToShortMap_(*this, CommonAPI::SomeIP::eventgroup_id_t(0x1001), CommonAPI::SomeIP::event_id_t(0xa006), CommonAPI::SomeIP::method_id_t(0x2006), false, CommonAPI::SomeIP::reliability_type_e::RT_UNRELIABLE, false, static_cast< ::v2::Test::Audio::Controller_::StringToShortMapDeployment_t* >(nullptr)),
          focusStatusChanged_(*this, 0x1001, CommonAPI::SomeIP::event_id_t(0x9001), CommonAPI::SomeIP::event_type_e::ET_EVENT , CommonAPI::SomeIP::reliability_type_e::RT_UNRELIABLE, false, std::make_tuple(static_cast< CommonAPI::SomeIP::ArrayDeployment< ::v2::Test::Audio::Controller_::FocusStatusDeployment_t >* >(nullptr)))
{
}

ControllerSomeIPProxy::~ControllerSomeIPProxy() {
    completed_.set_value();
}

ControllerSomeIPProxy::IVIDeviceInfoAttribute& ControllerSomeIPProxy::getIVIDeviceInfoAttribute() {
    return iVIDeviceInfo_;
}
ControllerSomeIPProxy::AudioSourceTypesAttribute& ControllerSomeIPProxy::getAudioSourceTypesAttribute() {
    return audioSourceTypes_;
}
ControllerSomeIPProxy::VolumeInfoAttribute& ControllerSomeIPProxy::getVolumeInfoAttribute() {
    return volumeInfo_;
}
ControllerSomeIPProxy::KeyValueByteBufferMapAttribute& ControllerSomeIPProxy::getKeyValueByteBufferMapAttribute() {
    return keyValueByteBufferMap_;
}
ControllerSomeIPProxy::DeviceStateMapAttribute& ControllerSomeIPProxy::getDeviceStateMapAttribute() {
    return deviceStateMap_;
}
ControllerSomeIPProxy::StringToShortMapAttribute& ControllerSomeIPProxy::getStringToShortMapAttribute() {
    return stringToShortMap_;
}

ControllerSomeIPProxy::FocusStatusChangedEvent& ControllerSomeIPProxy::getFocusStatusChangedEvent() {
    return focusStatusChanged_;
}

/*
 * description: 
 * The ccRC system requests to obtain audio focus.
 */
void ControllerSomeIPProxy::ObtainFocus(std::string _audioSourceType, Controller::AudioDeviceType _device, CommonAPI::CallStatus &_internalCallStatus, Controller::FocusControlError &_error, Controller::AudioFocusResultType &_res, const CommonAPI::CallInfo *_info) {
    CommonAPI::Deployable< Controller::FocusControlError, ::v2::Test::Audio::Controller_::FocusControlErrorDeployment_t> deploy_error(static_cast< ::v2::Test::Audio::Controller_::FocusControlErrorDeployment_t * >(nullptr));
    CommonAPI::Deployable< std::string, CommonAPI::SomeIP::StringDeployment> deploy_audioSourceType(_audioSourceType, static_cast< CommonAPI::SomeIP::StringDeployment* >(nullptr));
    CommonAPI::Deployable< Controller::AudioDeviceType, ::v2::Test::Audio::Controller_::AudioDeviceTypeDeployment_t> deploy_device(_device, static_cast< ::v2::Test::Audio::Controller_::AudioDeviceTypeDeployment_t* >(nullptr));
    CommonAPI::Deployable< Controller::AudioFocusResultType, ::v2::Test::Audio::Controller_::AudioFocusResultTypeDeployment_t> deploy_res(static_cast< ::v2::Test::Audio::Controller_::AudioFocusResultTypeDeployment_t* >(nullptr));
    CommonAPI::SomeIP::ProxyHelper<
        CommonAPI::SomeIP::SerializableArguments<
            CommonAPI::Deployable<
                std::string,
                CommonAPI::SomeIP::StringDeployment
            >,
            CommonAPI::Deployable<
                Controller::AudioDeviceType,
                ::v2::Test::Audio::Controller_::AudioDeviceTypeDeployment_t
            >
        >,
        CommonAPI::SomeIP::SerializableArguments<
            CommonAPI::Deployable<
                Controller::FocusControlError,
                ::v2::Test::Audio::Controller_::FocusControlErrorDeployment_t
            >,
            CommonAPI::Deployable<
                Controller::AudioFocusResultType,
                ::v2::Test::Audio::Controller_::AudioFocusResultTypeDeployment_t
            >
        >
    >::callMethodWithReply(
        *this,
        CommonAPI::SomeIP::method_id_t(0x1001),
        false,
        false,
        (_info ? _info : &CommonAPI::SomeIP::defaultCallInfo),
        deploy_audioSourceType, deploy_device,
        _internalCallStatus,
        deploy_error,
        deploy_res);
    _error = deploy_error.getValue();
    _res = deploy_res.getValue();
}

std::future<CommonAPI::CallStatus> ControllerSomeIPProxy::ObtainFocusAsync(const std::string &_audioSourceType, const Controller::AudioDeviceType &_device, ObtainFocusAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
    CommonAPI::Deployable< Controller::FocusControlError, ::v2::Test::Audio::Controller_::FocusControlErrorDeployment_t> deploy_error(static_cast< ::v2::Test::Audio::Controller_::FocusControlErrorDeployment_t * >(nullptr));
    CommonAPI::Deployable< std::string, CommonAPI::SomeIP::StringDeployment> deploy_audioSourceType(_audioSourceType, static_cast< CommonAPI::SomeIP::StringDeployment* >(nullptr));
    CommonAPI::Deployable< Controller::AudioDeviceType, ::v2::Test::Audio::Controller_::AudioDeviceTypeDeployment_t> deploy_device(_device, static_cast< ::v2::Test::Audio::Controller_::AudioDeviceTypeDeployment_t* >(nullptr));
    CommonAPI::Deployable< Controller::AudioFocusResultType, ::v2::Test::Audio::Controller_::AudioFocusResultTypeDeployment_t> deploy_res(static_cast< ::v2::Test::Audio::Controller_::AudioFocusResultTypeDeployment_t* >(nullptr));
    return CommonAPI::SomeIP::ProxyHelper<
        CommonAPI::SomeIP::SerializableArguments<
            CommonAPI::Deployable<
                std::string,
                CommonAPI::SomeIP::StringDeployment
            >,
            CommonAPI::Deployable<
                Controller::AudioDeviceType,
                ::v2::Test::Audio::Controller_::AudioDeviceTypeDeployment_t
            >
        >,
        CommonAPI::SomeIP::SerializableArguments<
            CommonAPI::Deployable<
                Controller::FocusControlError,
                ::v2::Test::Audio::Controller_::FocusControlErrorDeployment_t
            >,
            CommonAPI::Deployable<
                Controller::AudioFocusResultType,
                ::v2::Test::Audio::Controller_::AudioFocusResultTypeDeployment_t
            >
        >
    >::callMethodAsync(
        *this,
        CommonAPI::SomeIP::method_id_t(0x1001),
        false,
        false,
        (_info ? _info : &CommonAPI::SomeIP::defaultCallInfo),
        deploy_audioSourceType, deploy_device,
        [_callback] (CommonAPI::CallStatus _internalCallStatus, CommonAPI::Deployable< Controller::FocusControlError, ::v2::Test::Audio::Controller_::FocusControlErrorDeployment_t > _deploy_error, CommonAPI::Deployable< Controller::AudioFocusResultType, ::v2::Test::Audio::Controller_::AudioFocusResultTypeDeployment_t > _res) {
            if (_callback)
                _callback(_internalCallStatus, _deploy_error.getValue(), _res.getValue());
        },
        std::make_tuple(deploy_error, deploy_res));
}

/*
 * description: 
 * The ccRC system requests to release audio focus.  Requests that cannot be released return errors.
 */
void ControllerSomeIPProxy::ReleaseFocus(std::string _audioSourceType, Controller::AudioDeviceType _device, CommonAPI::CallStatus &_internalCallStatus, Controller::FocusControlError &_error, const CommonAPI::CallInfo *_info) {
    CommonAPI::Deployable< Controller::FocusControlError, ::v2::Test::Audio::Controller_::FocusControlErrorDeployment_t> deploy_error(static_cast< ::v2::Test::Audio::Controller_::FocusControlErrorDeployment_t * >(nullptr));
    CommonAPI::Deployable< std::string, CommonAPI::SomeIP::StringDeployment> deploy_audioSourceType(_audioSourceType, static_cast< CommonAPI::SomeIP::StringDeployment* >(nullptr));
    CommonAPI::Deployable< Controller::AudioDeviceType, ::v2::Test::Audio::Controller_::AudioDeviceTypeDeployment_t> deploy_device(_device, static_cast< ::v2::Test::Audio::Controller_::AudioDeviceTypeDeployment_t* >(nullptr));
    CommonAPI::SomeIP::ProxyHelper<
        CommonAPI::SomeIP::SerializableArguments<
            CommonAPI::Deployable<
                std::string,
                CommonAPI::SomeIP::StringDeployment
            >,
            CommonAPI::Deployable<
                Controller::AudioDeviceType,
                ::v2::Test::Audio::Controller_::AudioDeviceTypeDeployment_t
            >
        >,
        CommonAPI::SomeIP::SerializableArguments<
            CommonAPI::Deployable<
                Controller::FocusControlError,
                ::v2::Test::Audio::Controller_::FocusControlErrorDeployment_t
            >
        >
    >::callMethodWithReply(
        *this,
        CommonAPI::SomeIP::method_id_t(0x1002),
        false,
        false,
        (_info ? _info : &CommonAPI::SomeIP::defaultCallInfo),
        deploy_audioSourceType, deploy_device,
        _internalCallStatus,
        deploy_error);
    _error = deploy_error.getValue();
}

std::future<CommonAPI::CallStatus> ControllerSomeIPProxy::ReleaseFocusAsync(const std::string &_audioSourceType, const Controller::AudioDeviceType &_device, ReleaseFocusAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
    CommonAPI::Deployable< Controller::FocusControlError, ::v2::Test::Audio::Controller_::FocusControlErrorDeployment_t> deploy_error(static_cast< ::v2::Test::Audio::Controller_::FocusControlErrorDeployment_t * >(nullptr));
    CommonAPI::Deployable< std::string, CommonAPI::SomeIP::StringDeployment> deploy_audioSourceType(_audioSourceType, static_cast< CommonAPI::SomeIP::StringDeployment* >(nullptr));
    CommonAPI::Deployable< Controller::AudioDeviceType, ::v2::Test::Audio::Controller_::AudioDeviceTypeDeployment_t> deploy_device(_device, static_cast< ::v2::Test::Audio::Controller_::AudioDeviceTypeDeployment_t* >(nullptr));
    return CommonAPI::SomeIP::ProxyHelper<
        CommonAPI::SomeIP::SerializableArguments<
            CommonAPI::Deployable<
                std::string,
                CommonAPI::SomeIP::StringDeployment
            >,
            CommonAPI::Deployable<
                Controller::AudioDeviceType,
                ::v2::Test::Audio::Controller_::AudioDeviceTypeDeployment_t
            >
        >,
        CommonAPI::SomeIP::SerializableArguments<
            CommonAPI::Deployable<
                Controller::FocusControlError,
                ::v2::Test::Audio::Controller_::FocusControlErrorDeployment_t
            >
        >
    >::callMethodAsync(
        *this,
        CommonAPI::SomeIP::method_id_t(0x1002),
        false,
        false,
        (_info ? _info : &CommonAPI::SomeIP::defaultCallInfo),
        deploy_audioSourceType, deploy_device,
        [_callback] (CommonAPI::CallStatus _internalCallStatus, CommonAPI::Deployable< Controller::FocusControlError, ::v2::Test::Audio::Controller_::FocusControlErrorDeployment_t > _deploy_error) {
            if (_callback)
                _callback(_internalCallStatus, _deploy_error.getValue());
        },
        std::make_tuple(deploy_error));
}

/*
 * description: 
 * Set the volume for outside the system.
 */
void ControllerSomeIPProxy::SetVolume(uint8_t _volume, CommonAPI::CallStatus &_internalCallStatus, Controller::VolumeControlError &_error, const CommonAPI::CallInfo *_info) {
    CommonAPI::Deployable< Controller::VolumeControlError, ::v2::Test::Audio::Controller_::VolumeControlErrorDeployment_t> deploy_error(static_cast< ::v2::Test::Audio::Controller_::VolumeControlErrorDeployment_t * >(nullptr));
    CommonAPI::Deployable< uint8_t, CommonAPI::SomeIP::IntegerDeployment<uint8_t>> deploy_volume(_volume, static_cast< CommonAPI::SomeIP::IntegerDeployment<uint8_t>* >(nullptr));
    CommonAPI::SomeIP::ProxyHelper<
        CommonAPI::SomeIP::SerializableArguments<
            CommonAPI::Deployable<
                uint8_t,
                CommonAPI::SomeIP::IntegerDeployment<uint8_t>
            >
        >,
        CommonAPI::SomeIP::SerializableArguments<
            CommonAPI::Deployable<
                Controller::VolumeControlError,
                ::v2::Test::Audio::Controller_::VolumeControlErrorDeployment_t
            >
        >
    >::callMethodWithReply(
        *this,
        CommonAPI::SomeIP::method_id_t(0x1004),
        false,
        false,
        (_info ? _info : &CommonAPI::SomeIP::defaultCallInfo),
        deploy_volume,
        _internalCallStatus,
        deploy_error);
    _error = deploy_error.getValue();
}

std::future<CommonAPI::CallStatus> ControllerSomeIPProxy::SetVolumeAsync(const uint8_t &_volume, SetVolumeAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
    CommonAPI::Deployable< Controller::VolumeControlError, ::v2::Test::Audio::Controller_::VolumeControlErrorDeployment_t> deploy_error(static_cast< ::v2::Test::Audio::Controller_::VolumeControlErrorDeployment_t * >(nullptr));
    CommonAPI::Deployable< uint8_t, CommonAPI::SomeIP::IntegerDeployment<uint8_t>> deploy_volume(_volume, static_cast< CommonAPI::SomeIP::IntegerDeployment<uint8_t>* >(nullptr));
    return CommonAPI::SomeIP::ProxyHelper<
        CommonAPI::SomeIP::SerializableArguments<
            CommonAPI::Deployable<
                uint8_t,
                CommonAPI::SomeIP::IntegerDeployment<uint8_t>
            >
        >,
        CommonAPI::SomeIP::SerializableArguments<
            CommonAPI::Deployable<
                Controller::VolumeControlError,
                ::v2::Test::Audio::Controller_::VolumeControlErrorDeployment_t
            >
        >
    >::callMethodAsync(
        *this,
        CommonAPI::SomeIP::method_id_t(0x1004),
        false,
        false,
        (_info ? _info : &CommonAPI::SomeIP::defaultCallInfo),
        deploy_volume,
        [_callback] (CommonAPI::CallStatus _internalCallStatus, CommonAPI::Deployable< Controller::VolumeControlError, ::v2::Test::Audio::Controller_::VolumeControlErrorDeployment_t > _deploy_error) {
            if (_callback)
                _callback(_internalCallStatus, _deploy_error.getValue());
        },
        std::make_tuple(deploy_error));
}

/*
 * description: 
 * request to set source volume.
 * There are two member field in the Input parameter.
 * - AudioSourceType: please see "AudioSourceTypes []" for finding detail description
 * - volume : it holds volume level and its level is depending on platform's audio  spec. (varies based on platform, model, misc.)
 * : when this method is invoked, audio manager need to update VolumeInfo.LastVolume
 * 
 * - maxVolume : it defines volume limitation which is described from the requirement
 * - VolumeControlError : please see "setVolume" for more detail explanation
 */
void ControllerSomeIPProxy::SetSourceVolume(std::string _audioSourceType, uint16_t _volume, uint32_t _maxVolume, CommonAPI::CallStatus &_internalCallStatus, Controller::VolumeControlError &_error, const CommonAPI::CallInfo *_info) {
    CommonAPI::Deployable< Controller::VolumeControlError, ::v2::Test::Audio::Controller_::VolumeControlErrorDeployment_t> deploy_error(static_cast< ::v2::Test::Audio::Controller_::VolumeControlErrorDeployment_t * >(nullptr));
    CommonAPI::Deployable< std::string, CommonAPI::SomeIP::StringDeployment> deploy_audioSourceType(_audioSourceType, static_cast< CommonAPI::SomeIP::StringDeployment* >(nullptr));
    CommonAPI::Deployable< uint16_t, CommonAPI::SomeIP::IntegerDeployment<uint16_t>> deploy_volume(_volume, static_cast< CommonAPI::SomeIP::IntegerDeployment<uint16_t>* >(nullptr));
    CommonAPI::Deployable< uint32_t, CommonAPI::SomeIP::IntegerDeployment<uint32_t>> deploy_maxVolume(_maxVolume, static_cast< CommonAPI::SomeIP::IntegerDeployment<uint32_t>* >(nullptr));
    CommonAPI::SomeIP::ProxyHelper<
        CommonAPI::SomeIP::SerializableArguments<
            CommonAPI::Deployable<
                std::string,
                CommonAPI::SomeIP::StringDeployment
            >,
            CommonAPI::Deployable<
                uint16_t,
                CommonAPI::SomeIP::IntegerDeployment<uint16_t>
            >,
            CommonAPI::Deployable<
                uint32_t,
                CommonAPI::SomeIP::IntegerDeployment<uint32_t>
            >
        >,
        CommonAPI::SomeIP::SerializableArguments<
            CommonAPI::Deployable<
                Controller::VolumeControlError,
                ::v2::Test::Audio::Controller_::VolumeControlErrorDeployment_t
            >
        >
    >::callMethodWithReply(
        *this,
        CommonAPI::SomeIP::method_id_t(0x1009),
        false,
        false,
        (_info ? _info : &CommonAPI::SomeIP::defaultCallInfo),
        deploy_audioSourceType, deploy_volume, deploy_maxVolume,
        _internalCallStatus,
        deploy_error);
    _error = deploy_error.getValue();
}

std::future<CommonAPI::CallStatus> ControllerSomeIPProxy::SetSourceVolumeAsync(const std::string &_audioSourceType, const uint16_t &_volume, const uint32_t &_maxVolume, SetSourceVolumeAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
    CommonAPI::Deployable< Controller::VolumeControlError, ::v2::Test::Audio::Controller_::VolumeControlErrorDeployment_t> deploy_error(static_cast< ::v2::Test::Audio::Controller_::VolumeControlErrorDeployment_t * >(nullptr));
    CommonAPI::Deployable< std::string, CommonAPI::SomeIP::StringDeployment> deploy_audioSourceType(_audioSourceType, static_cast< CommonAPI::SomeIP::StringDeployment* >(nullptr));
    CommonAPI::Deployable< uint16_t, CommonAPI::SomeIP::IntegerDeployment<uint16_t>> deploy_volume(_volume, static_cast< CommonAPI::SomeIP::IntegerDeployment<uint16_t>* >(nullptr));
    CommonAPI::Deployable< uint32_t, CommonAPI::SomeIP::IntegerDeployment<uint32_t>> deploy_maxVolume(_maxVolume, static_cast< CommonAPI::SomeIP::IntegerDeployment<uint32_t>* >(nullptr));
    return CommonAPI::SomeIP::ProxyHelper<
        CommonAPI::SomeIP::SerializableArguments<
            CommonAPI::Deployable<
                std::string,
                CommonAPI::SomeIP::StringDeployment
            >,
            CommonAPI::Deployable<
                uint16_t,
                CommonAPI::SomeIP::IntegerDeployment<uint16_t>
            >,
            CommonAPI::Deployable<
                uint32_t,
                CommonAPI::SomeIP::IntegerDeployment<uint32_t>
            >
        >,
        CommonAPI::SomeIP::SerializableArguments<
            CommonAPI::Deployable<
                Controller::VolumeControlError,
                ::v2::Test::Audio::Controller_::VolumeControlErrorDeployment_t
            >
        >
    >::callMethodAsync(
        *this,
        CommonAPI::SomeIP::method_id_t(0x1009),
        false,
        false,
        (_info ? _info : &CommonAPI::SomeIP::defaultCallInfo),
        deploy_audioSourceType, deploy_volume, deploy_maxVolume,
        [_callback] (CommonAPI::CallStatus _internalCallStatus, CommonAPI::Deployable< Controller::VolumeControlError, ::v2::Test::Audio::Controller_::VolumeControlErrorDeployment_t > _deploy_error) {
            if (_callback)
                _callback(_internalCallStatus, _deploy_error.getValue());
        },
        std::make_tuple(deploy_error));
}

/*
 * description: 
 * Get FocusStatus and VolumeInfo for audio source type
 */
void ControllerSomeIPProxy::GetAudioSourceStatus(std::string _audioSourceType, CommonAPI::CallStatus &_internalCallStatus, Controller::ErrorType &_error, Controller::AudioSourceStatusInfo &_audioSourceStatusInfo, const CommonAPI::CallInfo *_info) {
    CommonAPI::Deployable< Controller::ErrorType, ::v2::Test::Audio::Controller_::ErrorTypeDeployment_t> deploy_error(static_cast< ::v2::Test::Audio::Controller_::ErrorTypeDeployment_t * >(nullptr));
    CommonAPI::Deployable< std::string, CommonAPI::SomeIP::StringDeployment> deploy_audioSourceType(_audioSourceType, static_cast< CommonAPI::SomeIP::StringDeployment* >(nullptr));
    CommonAPI::Deployable< Controller::AudioSourceStatusInfo, ::v2::Test::Audio::Controller_::AudioSourceStatusInfoDeployment_t> deploy_audioSourceStatusInfo(static_cast< ::v2::Test::Audio::Controller_::AudioSourceStatusInfoDeployment_t* >(nullptr));
    CommonAPI::SomeIP::ProxyHelper<
        CommonAPI::SomeIP::SerializableArguments<
            CommonAPI::Deployable<
                std::string,
                CommonAPI::SomeIP::StringDeployment
            >
        >,
        CommonAPI::SomeIP::SerializableArguments<
            CommonAPI::Deployable<
                Controller::ErrorType,
                ::v2::Test::Audio::Controller_::ErrorTypeDeployment_t
            >,
            CommonAPI::Deployable<
                Controller::AudioSourceStatusInfo,
                ::v2::Test::Audio::Controller_::AudioSourceStatusInfoDeployment_t
            >
        >
    >::callMethodWithReply(
        *this,
        CommonAPI::SomeIP::method_id_t(0x100a),
        false,
        false,
        (_info ? _info : &CommonAPI::SomeIP::defaultCallInfo),
        deploy_audioSourceType,
        _internalCallStatus,
        deploy_error,
        deploy_audioSourceStatusInfo);
    _error = deploy_error.getValue();
    _audioSourceStatusInfo = deploy_audioSourceStatusInfo.getValue();
}

std::future<CommonAPI::CallStatus> ControllerSomeIPProxy::GetAudioSourceStatusAsync(const std::string &_audioSourceType, GetAudioSourceStatusAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
    CommonAPI::Deployable< Controller::ErrorType, ::v2::Test::Audio::Controller_::ErrorTypeDeployment_t> deploy_error(static_cast< ::v2::Test::Audio::Controller_::ErrorTypeDeployment_t * >(nullptr));
    CommonAPI::Deployable< std::string, CommonAPI::SomeIP::StringDeployment> deploy_audioSourceType(_audioSourceType, static_cast< CommonAPI::SomeIP::StringDeployment* >(nullptr));
    CommonAPI::Deployable< Controller::AudioSourceStatusInfo, ::v2::Test::Audio::Controller_::AudioSourceStatusInfoDeployment_t> deploy_audioSourceStatusInfo(static_cast< ::v2::Test::Audio::Controller_::AudioSourceStatusInfoDeployment_t* >(nullptr));
    return CommonAPI::SomeIP::ProxyHelper<
        CommonAPI::SomeIP::SerializableArguments<
            CommonAPI::Deployable<
                std::string,
                CommonAPI::SomeIP::StringDeployment
            >
        >,
        CommonAPI::SomeIP::SerializableArguments<
            CommonAPI::Deployable<
                Controller::ErrorType,
                ::v2::Test::Audio::Controller_::ErrorTypeDeployment_t
            >,
            CommonAPI::Deployable<
                Controller::AudioSourceStatusInfo,
                ::v2::Test::Audio::Controller_::AudioSourceStatusInfoDeployment_t
            >
        >
    >::callMethodAsync(
        *this,
        CommonAPI::SomeIP::method_id_t(0x100a),
        false,
        false,
        (_info ? _info : &CommonAPI::SomeIP::defaultCallInfo),
        deploy_audioSourceType,
        [_callback] (CommonAPI::CallStatus _internalCallStatus, CommonAPI::Deployable< Controller::ErrorType, ::v2::Test::Audio::Controller_::ErrorTypeDeployment_t > _deploy_error, CommonAPI::Deployable< Controller::AudioSourceStatusInfo, ::v2::Test::Audio::Controller_::AudioSourceStatusInfoDeployment_t > _audioSourceStatusInfo) {
            if (_callback)
                _callback(_internalCallStatus, _deploy_error.getValue(), _audioSourceStatusInfo.getValue());
        },
        std::make_tuple(deploy_error, deploy_audioSourceStatusInfo));
}

void ControllerSomeIPProxy::getOwnVersion(uint16_t& ownVersionMajor, uint16_t& ownVersionMinor) const {
    ownVersionMajor = 2;
    ownVersionMinor = 0;
}

std::future<void> ControllerSomeIPProxy::getCompletionFuture() {
    return completed_.get_future();
}

} // namespace Audio
} // namespace Test
} // namespace v2
